import { ComponentType } from 'discord-api-types/v10';
import { ButtonBuilder } from './Button';
import { SelectMenuBuilder } from './SelectMenu';
import { TextInputBuilder } from './TextInput';
import { ActionRowBuilder as DjsActionRowBuilder, APIMessageActionRowComponent, ActionRow, MessageActionRowComponent, APIActionRowComponent, APIModalActionRowComponent } from 'discord.js';
import { JSONEncodable } from '@discordjs/util';
export declare type ActionRowComponents = JSONEncodable<APIActionRowComponent<APIMessageActionRowComponent | APIModalActionRowComponent>> | APIActionRowComponent<APIMessageActionRowComponent | APIModalActionRowComponent> | ActionRowBuilder | ActionRow<MessageActionRowComponent> | ButtonBuilder[] | SelectMenuBuilder[] | TextInputBuilder[] | ActionRowBuilder[];
export declare class ActionRowBuilder extends DjsActionRowBuilder<any> {
    type: ComponentType;
    components: ButtonBuilder[] | SelectMenuBuilder[] | TextInputBuilder[] | ActionRowBuilder[] | ActionRow<MessageActionRowComponent>[] | MessageActionRowComponent[];
    constructor(components: ButtonBuilder[] | SelectMenuBuilder[] | TextInputBuilder[] | ActionRowBuilder[] | ActionRow<MessageActionRowComponent>[] | MessageActionRowComponent[]);
    from(other: ActionRowComponents): ActionRowBuilder;
}
export { ButtonBuilder, SelectMenuBuilder, TextInputBuilder };
