"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextInputBuilder = exports.SelectMenuBuilder = exports.ButtonBuilder = exports.ActionRowBuilder = void 0;
const v10_1 = require("discord-api-types/v10");
const Button_1 = require("./Button");
Object.defineProperty(exports, "ButtonBuilder", { enumerable: true, get: function () { return Button_1.ButtonBuilder; } });
const SelectMenu_1 = require("./SelectMenu");
Object.defineProperty(exports, "SelectMenuBuilder", { enumerable: true, get: function () { return SelectMenu_1.SelectMenuBuilder; } });
const TextInput_1 = require("./TextInput");
Object.defineProperty(exports, "TextInputBuilder", { enumerable: true, get: function () { return TextInput_1.TextInputBuilder; } });
const discord_js_1 = require("discord.js");
class ActionRowBuilder extends discord_js_1.ActionRowBuilder {
    type = v10_1.ComponentType.ActionRow;
    components = [];
    constructor(components) {
        super();
        if (components instanceof ActionRowBuilder || components instanceof (discord_js_1.ActionRow)) {
            this.components = components.components;
            this.type = components.type;
            this.data.components = components.components;
        }
        else if (Array.isArray(components)) {
            this.components = components ?? [];
            this.data.components = this.components;
        }
    }
    from(other) {
        if ((0, discord_js_1.isJSONEncodable)(other)) {
            return new ActionRowBuilder(other.toJSON());
        }
        return new ActionRowBuilder(other);
    }
}
exports.ActionRowBuilder = ActionRowBuilder;
