"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ButtonStyle = exports.ButtonBuilder = void 0;
const v10_1 = require("discord-api-types/v10");
Object.defineProperty(exports, "ButtonStyle", { enumerable: true, get: function () { return v10_1.ButtonStyle; } });
const getEmojis_1 = require("../utils/getEmojis");
const discord_js_1 = require("discord.js");
class ButtonBuilder extends discord_js_1.ButtonBuilder {
    type;
    style;
    label;
    emoji;
    custom_id;
    url;
    disabled;
    constructor(data) {
        super();
        this.type = v10_1.ComponentType.Button;
        this.label = data.label;
        if (typeof data.emoji === 'string') {
            const emoji = (0, getEmojis_1.getEmojis)(data.emoji)[0];
            if (emoji) {
                this.emoji = {
                    name: emoji.name,
                    id: emoji.id,
                    animated: emoji.animated
                };
            }
        }
        else {
            if (data.emoji) {
                this.emoji = {
                    name: data.emoji?.name,
                    id: data.emoji?.id
                };
                if (data.emoji?.animated) {
                    this.emoji.animated = data.emoji.animated;
                }
            }
        }
        this.style = data.style;
        if (data.custom_id) {
            this.custom_id = data.custom_id;
            this.data.custom_id = this.custom_id;
        }
        else {
            delete this.data.custom_id;
        }
        if (data.url) {
            this.url = data.url;
            this.data.url = this.url;
        }
        if (data.emoji !== undefined) {
            this.data.emoji = this.emoji;
        }
        else {
            delete this.data.emoji;
        }
        this.disabled = data.disabled ?? false;
        this.data.type = this.type;
        this.data.style = this.style;
        this.data.label = this.label;
        this.data.disabled = this.disabled;
    }
}
exports.ButtonBuilder = ButtonBuilder;
