"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectMenuOptionBuilder = void 0;
const discord_js_1 = require("discord.js");
const getEmojis_1 = require("../utils/getEmojis");
class SelectMenuOptionBuilder extends discord_js_1.SelectMenuOptionBuilder {
    label;
    value;
    description;
    emoji;
    default;
    constructor(data) {
        super();
        this.label = data.label;
        this.value = data.value;
        if (data.description) {
            this.description = data.description;
        }
        if (typeof data.emoji === 'string') {
            const emoji = (0, getEmojis_1.getEmojis)(data.emoji)[0];
            if (emoji) {
                this.emoji = {
                    name: emoji.name,
                    id: emoji.id,
                    animated: emoji.animated
                };
            }
        }
        else if (data.emoji) {
            if (data.emoji.id === null) {
                delete data.emoji;
            }
            else {
                this.emoji = {
                    name: data.emoji?.name,
                    id: data.emoji?.id
                };
                if (data.emoji?.animated) {
                    this.emoji.animated = data.emoji.animated;
                }
            }
        }
        if (data.emoji) {
            this.data.emoji = this.emoji;
        }
        else {
            delete this.data.emoji;
            delete this.emoji;
        }
        if (data.description) {
            this.description = data.description;
            this.data.description = this.description;
        }
        else {
            delete this.description;
        }
        this.default = data.default ?? false;
        this.data.label = this.label;
        this.data.value = this.value;
    }
}
exports.SelectMenuOptionBuilder = SelectMenuOptionBuilder;
